'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Cell = require('./Cell');

var _Cell2 = _interopRequireDefault(_Cell);

var _ClassNameMixin = require('./mixins/ClassNameMixin');

var _ClassNameMixin2 = _interopRequireDefault(_ClassNameMixin);

var _ColumnResizeHandle = require('./ColumnResizeHandle');

var _ColumnResizeHandle2 = _interopRequireDefault(_ColumnResizeHandle);

var _isIE = require('./utils/isIE8');

var _isIE2 = _interopRequireDefault(_isIE);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HeaderCell = _react2.default.createClass({
    displayName: 'HeaderCell',

    mixins: [_ClassNameMixin2.default],
    propTypes: {
        sort: _react.PropTypes.bool,
        resizable: _react.PropTypes.bool,
        onColumnResizeEnd: _react.PropTypes.func,
        onColumnResize: _react.PropTypes.func,
        onColumnResizeMove: _react.PropTypes.func
    },
    _onColumnResize: function _onColumnResize(width, left, event) {
        this.setState({
            columnWidth: width,
            initialEvent: event
        });
        this.props.onColumnResize(width, left, event);
    },
    _onColumnResizeEnd: function _onColumnResizeEnd(columnWidth, cursorDelta) {
        this.setState({
            columnWidth: columnWidth
        });
        this.props.onColumnResizeEnd(columnWidth, cursorDelta, this.props.dataKey);
    },
    getInitialState: function getInitialState() {
        return {
            columnWidth: this.props.width
        };
    },
    renderResizeSpanner: function renderResizeSpanner() {
        var _props = this.props;
        var resizable = _props.resizable;
        var left = _props.left;
        var onColumnResizeMove = _props.onColumnResizeMove;
        var fixed = _props.fixed;
        var _state = this.state;
        var columnWidth = _state.columnWidth;
        var initialEvent = _state.initialEvent;


        if (!resizable) {
            return null;
        }

        return _react2.default.createElement(_ColumnResizeHandle2.default, {
            columnWidth: columnWidth,
            columnLeft: left,
            columnFixed: fixed,
            initialEvent: initialEvent,
            onColumnResizeMove: onColumnResizeMove,
            onColumnResize: this._onColumnResize,
            onColumnResizeEnd: this._onColumnResizeEnd
        });
    },
    render: function render() {

        var classes = this.prefix('cell-header');

        return _react2.default.createElement(
            'div',
            { className: classes },
            _react2.default.createElement(_Cell2.default, _extends({ isHeaderCell: true }, this.props)),
            !_isIE2.default && this.renderResizeSpanner()
        );
    }
});

exports.default = HeaderCell;